package xyz.veronie.bgg.localdb;

import java.sql.SQLException;
import java.util.List;

import xyz.veronie.bgg.result.Thing;

public class LocalDbAdapterService {
	private SqliteController sqliteController;
	
	public LocalDbAdapterService() {
		initDb();
	}
	
	private void initDb() {
		sqliteController = SqliteController.getInstance();
		sqliteController.createSchema();
	}


	/// Add a list of things with the given name (overwriting the old one)
	// TODO: handle ask before overwrite
	public void storeThingList(List<Thing> things, String name) throws SQLException {
		sqliteController.deleteThingList(name);
		sqliteController.createThingListIfNotExists(name);
		sqliteController.addToThingList(name, things);
	}

	public List<Thing> loadThingList(String name) throws SQLException {
		if(sqliteController.hasThingList(name)) {
			return sqliteController.getThingList(name);
		}
		return null;
	}

	public List<String> loadThingListNames() throws SQLException {
		return sqliteController.getThingLists();
	}
	
}
