package xyz.veronie.bgg.result;

import java.util.ArrayList;
import java.util.List;

import xyz.veronie.bgg.result.internal.OutputResultHelper;

public class ThingDetails {
	Integer id;
	String name;
	String description;
	String image;
	String comment;

	Integer yearpublished;
	Integer minplayers;
	Integer maxplayers;

	List<IdString> designer;
	List<IdString> publisher;
	List<IdString> artist;

	List<IdString> category;
	List<IdString> mechanic;
	List<IdString> expansion;
	List<IdString> domain;
	List<IdString> family;
	

	Integer playingtime;
	Integer minplaytime;
	Integer maxplaytime;

	// poll suggested_numplayers
	// The index in the list indicates the number of players
	// Recommendation indicates how well it plays based on what the majority thinks
	List<Recommendation> players; 
	
	// poll suggested_playerage
	Float age_poll;
	
	Integer age;
	Integer usersrated;
	Float average;
	Float bayesaverage;
	Integer rank;
	Integer rank_wg;
	Integer numcomments;
	Integer numweights;
	Float averageweight;
	Float stddev;
	Float median;

	Integer owning;
	Integer trading;
	Integer wanting;
	Integer wishing;
		


	//	Integer basegameId;
//	Integer reimplementId;
//	String reimplement_name;
//	Integer reimplementedById;
//	String reimplementedByName;
//	Integer containsId;
//	String containsName;
//	Integer iscontained;
//	String iscontained_name;
//	Integer integration;
//	String integration_name;
	Integer numplays;
	Float price;
	Integer expansions;
	
	public ThingDetails() {
		players = new ArrayList<Recommendation>();
		
		designer = new ArrayList<IdString>();
		publisher = new ArrayList<IdString>();
		artist = new ArrayList<IdString>();
		category = new ArrayList<IdString>();
		mechanic = new ArrayList<IdString>();
		expansion = new ArrayList<IdString>();
		domain = new ArrayList<IdString>();
		family = new ArrayList<IdString>();
	}
	
	public String toResultTextLine() {
		StringBuilder str = new StringBuilder();
		
		// designer,publisher,artist,yearpublished,minplayers,maxplayers,playingtime,minplaytime,maxplaytime,
        // age,usersrated,average,bayesaverage,rank,rank_wg,numcomments,numweights,averageweight,stddev,median,
		// category,mechanic,
		OutputResultHelper.appendToResult(str, OutputResultHelper.getFirstIdListItem(designer));
		OutputResultHelper.appendToResult(str, OutputResultHelper.getFirstIdListItem(publisher));
		OutputResultHelper.appendToResult(str, OutputResultHelper.getFirstIdListItem(artist));
		OutputResultHelper.appendToResult(str, yearpublished);
		OutputResultHelper.appendToResult(str, minplayers);
		OutputResultHelper.appendToResult(str, maxplayers);
		OutputResultHelper.appendToResult(str, playingtime);
		OutputResultHelper.appendToResult(str, minplaytime);
		OutputResultHelper.appendToResult(str, maxplaytime);
		OutputResultHelper.appendToResult(str, age);
		OutputResultHelper.appendToResult(str, usersrated);
		OutputResultHelper.appendToResult(str, average);
		OutputResultHelper.appendToResult(str, bayesaverage);
		OutputResultHelper.appendToResult(str, rank);
		OutputResultHelper.appendToResult(str, rank_wg);
		OutputResultHelper.appendToResult(str, numcomments);
		OutputResultHelper.appendToResult(str, numweights);
		OutputResultHelper.appendToResult(str, averageweight);
		OutputResultHelper.appendToResult(str, stddev);
		OutputResultHelper.appendToResult(str, median);
		OutputResultHelper.appendToResult(str, category);
		OutputResultHelper.appendToResult(str, mechanic);

		// owned,trading,wanting,wishing
		OutputResultHelper.appendToResult(str, owning);
		OutputResultHelper.appendToResult(str, trading);
		OutputResultHelper.appendToResult(str, wanting);
		OutputResultHelper.appendToResult(str, wishing);

		// 1player,2player,3player,4player,5player,6player,7player,8player,9player,10player,
        // 11player,12player,13player,14player,15player,16player,17player,18player,19player,20player,
		for(int i = 0; i < players.size(); ++i) {
			Recommendation r = players.get(i);
			if(r != null) {
				str.append(r.name());
			}
			str.append(",");
    	}

    	// description,exp,
		OutputResultHelper.appendToResult(str, description);
		OutputResultHelper.appendToResult(str, expansion);

		
		// basegame,reimplement,reimplement_name,reimplemented,reimplemented_name,
		// contains,contains_name,iscontained,iscontained_name,integration,integration_name,
		// TODO: 
//		str.append(basegameId).append(",");
//		str.append(reimplementId).append(",");
//		str.append(reimplement_name).append(",");
//		str.append(reimplementedById).append(",");
//		str.append(reimplementedByName).append(",");
//		str.append(containsId).append(",");
//		str.append(containsName).append(",");
//		str.append(iscontained).append(",");
//		str.append(iscontained_name).append(",");
//		str.append(integration).append(",");
//		str.append(integration_name).append(",");
//		str.append("0,,\"\",,\"\",,\"\",,\"\",,\"\"");
		
		// price,expansions,domain,family,age_poll
		OutputResultHelper.appendToResult(str, price);
		OutputResultHelper.appendToResult(str, expansions);
		OutputResultHelper.appendToResult(str, domain);
		OutputResultHelper.appendToResult(str, family);
		str.append(OutputResultHelper.floatToResult(age_poll));

		return str.toString();
	}


	public static String emptyReplacerLine() {
		return ",,,,,,,,,,,0.0,0.0,,,0,0,0.0,0.0,0.0,\"\",\"\",,,,,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,\"\",\"\",0.0,,\"\",\"\",0.0";
	}

	public static String resultHeader() {
		return "designer,publisher,artist,yearpublished,minplayers,maxplayers,playingtime,minplaytime,maxplaytime,age,usersrated,average,bayesaverage,rank,rank_wg,numcomments,numweights,averageweight,stddev,median,category,mechanic,owned,trading,wanting,wishing,1player,2player,3player,4player,5player,6player,7player,8player,9player,10player,11player,12player,13player,14player,15player,16player,17player,18player,19player,20player,description,exp,price,expansions,domain,family,age_poll";				
		// not doing: basegame,reimplement,reimplement_name,reimplemented,reimplemented_name,contains,contains_name,iscontained,iscontained_name,integration,integration_name,
	}


}
