package xyz.veronie.bgg.result.internal;

import java.util.List;

import xyz.veronie.bgg.result.IdString;

public class OutputResultHelper {
	
	public static String floatToResult(Float f) {
		if(f == null || f == 0.0) {
			return "N/A";
		} else {
			return Float.toString(f.floatValue());
		}
	}


	public static String getFirstIdListItem(List<IdString> list) {
		if(list != null && list.size() > 0) { 
			return list.get(0).string;
		}
		return "";
	}

	public static void appendToResult(StringBuilder str, String string) {
		str.append("\"");
		if(string != null) {
			str.append(string);
		}
		str.append("\",");
	}
	
	public static void appendToResult(StringBuilder str, Integer i) {
		if(i != null) {
			str.append(Integer.toString(i));
		}
		str.append(",");
	}

	public static void appendToResult(StringBuilder str, Float f) {
		str.append(OutputResultHelper.floatToResult(f)).append(",");
	}
	
	public static void appendToResult(StringBuilder str, List<IdString> list) {
		if(list == null) {
			str.append(",");
			return;
		}
		
		str.append("\"");
		String nanDeckSeparator = "";
		for (IdString idString : list) {
			str.append(nanDeckSeparator);
			nanDeckSeparator = "\\13\\";
			str.append(idString.string);
		}
		str.append("\",");
	}
	
}
