package xyz.veronie.bgg.types;

public enum FamilyType {
	ALL("any", ""),
	BG_FAMILY("board game family", "boardgamefamily"),
	RPG("RPG", "rpg"),
	RPG_PERIODIC("RPG periodical", "rpgperiodical");
	
	private String name; //< the display name
	private String familyApiString; //< the THINGTYPE string for BGG XMLAPI2
	
	private FamilyType(String name, String familyApiString) {
		this.name = name;
		this.familyApiString = familyApiString;
	}
	
	@Override
	public String toString() {
		return this.name;
	}

	/// return the string used in BGG XMLAPI2 to identify the thingtype
	public String toApiString() {
		return this.familyApiString;
	}

	public static FamilyType getEnum(String s) {
		if(ALL.name().equals(s)){
            return ALL;
        } else if(BG_FAMILY.name().equals(s)){
            return BG_FAMILY;
        } else if(RPG.name().equals(s)){
            return RPG;
        } else if(RPG_PERIODIC.name().equals(s)){
            return RPG_PERIODIC;
        }
		throw new IllegalArgumentException("No Enum specified for String '" + s + "'.");
	}
}
