package xyz.veronie.bgg.types;

public enum SourceFilter {

	BGG_USER("from BGG user"), //< by bgg user name (additional filters apply)
	GEEKLIST("from geeklist"), //< by geeklist id
	FAMILY("from family");   //< by family id
//	RANK("by rank"),     //< filter by rank
//	YEAR("by year"),     //< filter by year
//	AGE("by age"),      //< by age (w.r.t. publishing date)
//	SEARCH("search");   //< more complex search by name and other filters	

	private String name;
	
	private SourceFilter(String name) {
		this.name = name;
	}
	
	@Override
	public String toString() {
		return name;
	}
	
	public static SourceFilter getEnum(String s) {
        if(BGG_USER.name().equals(s)){
            return BGG_USER;
        } else if(GEEKLIST.name().equals(s)){
            return GEEKLIST;
        } else if(FAMILY.name().equals(s)){
            return FAMILY;
        }
        throw new IllegalArgumentException("No Enum specified for String '" + s + "'.");
    }
	
	
}
