package xyz.veronie.bgg.types;

public enum Subtype {
	BOARDGAME("Board games", "boardgame"),
	BGEXPANSION("Board game expansions", "boardgameexpansion"),
	BGACCESSORIES("Board game accessories", "boardgameaccessory"),
	RPG_ISSUES("RPG issues", "rpgissue"),
	RPG_ITEMS("RPG items", "rpgitem"),
	VIDEOGAMES("Video Games", "videogame");
			
	private String name; //< the display name
	private String thingTypeString; //< the THINGTYPE string for BGG XMLAPI2
	
	private Subtype(String name, String thingtypestr) {
		this.name = name;
		this.thingTypeString = thingtypestr;
	}
	
	@Override
	public String toString() {
		return this.name;
	}

	/// return the string used in BGG XMLAPI2 to identify the thingtype
	public String toApiString() {
		return this.thingTypeString;
	}

	public static Subtype getEnum(String s) {
		if(BOARDGAME.name().equals(s)){
            return BOARDGAME;
        } else if(BGEXPANSION.name().equals(s)){
            return BGEXPANSION;
        } else if(BGACCESSORIES.name().equals(s)){
            return BGACCESSORIES;
        } else if(RPG_ISSUES.name().equals(s)){
            return RPG_ISSUES;
        } else if(RPG_ITEMS.name().equals(s)){
            return RPG_ITEMS;
        } else if(VIDEOGAMES.name().equals(s)){
            return VIDEOGAMES;
        }
        throw new IllegalArgumentException("No Enum specified for String '" + s + "'.");
	}
	
}
