package xyz.veronie.bgg.ui.filters.composites;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class SwitchLabel extends Composite {
	private Label label;
	private boolean isTurnedOn;
	private Image imageOn;
	private Image imageOff;
	
	public SwitchLabel(Composite parent, int style) {
		super(parent, style);
		this.setLayout(new RowLayout());
		label = new Label(this, SWT.None);
		isTurnedOn = false;
	}
	
	/// set image for switch off state
	public void setOnImage(Image imageOn) {
		this.imageOn = imageOn;
	}

	/// set image for switch on state
	public void setOffImage(Image imageOff) {
		this.imageOff = imageOff;
	}

	/// Set switch state: true = on, false = off
	public void setState(boolean isTurnedOn) {
		this.isTurnedOn = isTurnedOn;
		setSwitchImage();
	}
	
	/// Get the switch state: true = on, false = off
	public boolean getState() {
		return isTurnedOn;
	}
	
	private void setSwitchImage() {
		label.setImage(isTurnedOn ? imageOn : imageOff);
		pack();
		layout();
	}
	
	@Override
	public void addMouseListener(MouseListener listener) {
		label.addMouseListener(listener);
	}
	
	@Override
	public void setEnabled(boolean enabled) {
		label.setEnabled(enabled);
	}
	
}
