 
package xyz.veronie.bgg.ui.handlers;

import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

import xyz.veronie.bgg.result.ThingProvider;
import xyz.veronie.bgg.types.EventConstants;
import xyz.veronie.bgg.ui.dialogs.SaveGameListDialog;

public class SaveGamelistHandler {

	
	@Inject
	ThingProvider thingProvider;
	
	public SaveGamelistHandler() {
	}
	
	@Execute
	public void execute(Shell shell, IEventBroker eventBroker) {

		if(thingProvider.numberOfThings() == 0) {
			MessageBox msgBox = new MessageBox(shell, SWT.ICON_WARNING | SWT.OK);
			msgBox.setMessage("To save an empty game list would be like drawing from an empty deck.");
			msgBox.open();
			return;
		}

		// TODO: handle existing name
		SaveGameListDialog saveDialog = new SaveGameListDialog(shell);
		saveDialog.open();

		int returnCode = saveDialog.getReturnCode();
		if(returnCode == Dialog.OK) {
			String listName = saveDialog.getEntryText();
			try {
				thingProvider.storeList(listName);
				eventBroker.post(EventConstants.TOPIC_THINGS_SAVED, listName);
			}
			catch (Exception e) {
				MessageBox msgBox = new MessageBox(shell, SWT.ICON_ERROR | SWT.OK);
				msgBox.setMessage("Could not save game list.");
				msgBox.open();
				e.printStackTrace();
			}
		}
		
		
		// ignore cancel
	}
	
	
	@CanExecute
	public boolean canExecute() {
		return thingProvider != null;
	}
		
}
