package xyz.veronie.bgg.ui.parts;


import javax.annotation.PostConstruct;
import javax.inject.Inject;


import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UIEventTopic;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.resource.LocalResourceManager;
import org.eclipse.jface.resource.ResourceManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import xyz.veronie.bgg.types.EventConstants;

public class StatusBar {

	private Label statusLabel;
	private Composite main;
	
	@PostConstruct
	public void createControls(Composite parent) {
		main = new Composite(parent, SWT.FILL);
		main.setLayout(new GridLayout());
		
		statusLabel = new Label(main, SWT.FILL);
		statusLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		// create the manager and bind to a widget
		// TODO: do I have to free the color? how?
		ResourceManager resManager =
		    new LocalResourceManager(JFaceResources.getResources(), statusLabel);
		statusLabel.setBackground(resManager.createColor(new RGB(255,255,0)));
	}
	
	
	@Inject
	@Optional
	private void subscribeTopicStatusChanged
	    (@UIEventTopic(EventConstants.TOPIC_STATUS)
	        String text) {
	    statusLabel.setText(text);
	    statusLabel.computeSize(SWT.DEFAULT, SWT.DEFAULT, true);
	    statusLabel.getParent().pack();
	    
	    System.out.println("Status: " + text);
	}
}
